; File:     Screen4.asm
;---------------------------------------
   .586
    .model  flat, stdcall
    option  casemap :none
; 
    include \masm32\include\windows.inc
    include \masm32\macros\macros.asm

    include \masm32\include\kernel32.inc
    include \masm32\include\user32.inc
    include \masm32\include\gdi32.inc
    include \masm32\include\Comctl32.inc
    
;----------------------------------------------
    includelib \masm32\lib\kernel32.lib
    includelib \masm32\lib\user32.lib
    includelib \masm32\lib\gdi32.lib
    includelib \masm32\lib\Comctl32.lib    
; 
WinMain     proto   :DWORD,:DWORD,:DWORD,:DWORD
CmdProc     proto   :DWORD,:DWORD,:DWORD,:DWORD 
WndProcA    proto   :DWORD,:DWORD,:DWORD,:DWORD

StatusProc  proto   :DWORD,:DWORD,:DWORD,:DWORD
EcraRes     proto   :DWORD,:DWORD,:DWORD,:DWORD
; 
CREATESTATUS  MACRO  hStatus, ID

       invoke CreateStatusWindow, WS_CHILD or WS_VISIBLE, NULL, hWnd, ID
       mov    hStatus, eax
       cmp     eax, 0
       je      @F
                                          
       ;---- [Size the Statusbar Control] ----
       mov     [_sbParts+0], 240
       mov     [_sbParts+4], 310       
       mov     [_sbParts+8], 980        ;580 
       mov     [_sbParts+12], -1       ; The last part extends to the end
       ;
       invoke     SendMessage, hStatus, SB_SETPARTS, 4, addr _sbParts
       invoke     MoveWindow, hStatus, 0, 0, 0, 0, TRUE
@@:
ENDM 
; 
DIALOGBOX         MACRO  Name, Proc
    invoke  DialogBoxParam, _hInstance, addr Name, _hWnd, addr Proc, 0 
ENDM
; 
LOADIMAGEM      MACRO   Name
                invoke  LoadBitmap, _hInstance, offset Name
                mov     _hBitmapX, eax
                invoke  SelectObject, _hMemDC, eax      
                mov     _oBitmapX, eax
ENDM
; ##############################################################################################
.const
MAIN_STYLE       equ WS_OVERLAPPEDWINDOW or WS_CLIPCHILDREN     
MAIN_EXTSTYLE    equ 300h

$ECRAWIDTH$      equ 1280              ; largura do exr
$ECRAHEIGHT$     equ 966               ; altura do ecr

;  ------------------------ To Change Display resolution ---------------------------------
FIELDSRES   EQU   DM_BITSPERPEL or DM_PELSWIDTH or DM_PELSHEIGHT or DM_DISPLAYFLAGS or \
                  DM_DISPLAYFREQUENCY
;----------- Menus ---------------------
IDM_Menu1        equ 1001
IDM_Menu2        equ 1002
IDM_Menu3        equ 1003
;---------------------------------------
IDC_TITLE1          equ 4000
IDC_TITLE2          equ 4001

IDC_RBN1            equ 1001
IDC_RBN2            equ 1002
IDC_RBN3            equ 1003
IDC_RBN4            equ 1004
IDC_RBN5            equ 1005
IDC_RBN6            equ 1006
IDC_RBN7            equ 1007
IDC_RBN8            equ 1008
IDC_RBN9            equ 1009
IDC_RBN10           equ 1010

IDC_COMUTA          equ 2000
IDC_FECHA           equ 2001

DM_BITSPERPEL       equ 40000h
DM_PELSWIDTH        equ 80000h
DM_PELSHEIGHT       equ 100000h
DM_DISPLAYFLAGS     equ 200000h
DM_DISPLAYFREQUENCY equ 400000h
;  Data Section 
.data
;---------------------------------------
_FontSSerif  db 'MS Sans Serif', 0
_FontComic   db 'Comic Sans MS', 0

_DlgMain     db 'EcraRes',0            ; Definido em rsrc.rc
_MenuName    db 'Menu',0               ; Definido em rsrc.rc
_hWnd        dd 0

;----------------------------------------
_ClassName   db 'WinClass',0
_WindowName  db 'Change Resolution',0

_BitMap0     db "TDBitmap0",0
_BitMap1     db "TDBitmap1",0

; -------  Status Bar -------------------
_StatClass   db 'msctls_statusbar32',0
_sbParts     dd 4 dup (0)
_hWndStat    dd 0
_wStatus     dd 0

;
; rea de Cliente
; --------------- 
_ClientLeftX    dd 0         
_ClientTopY     dd 0
_ClientDimX     dd 0         
_ClientDimY     dd 0
;
; rea de Cliente
; --------------- 
_MemLeftX       dd 0         
_MemTopY        dd 0
_MemDimX        dd 0    
_MemDimY        dd 0
;  Data? Section 
.data?
;---------------------------------------
_hInstance   dd ?
_hdc         dd ?

_hBmpMem     dd ?
_oBmpMem     dd ?

_hMemDC      dd ?
;---------------------------------------
_hBitmapX    dd ?
_oBitmapX    dd ?

_hBitmap0    dd ?
_hBitmap1    dd ?

_oBitmap0    dd ?
_oBitmap1    dd ?

_wcx         WNDCLASSEX <?>
_msg         MSG <?>
_icce        INITCOMMONCONTROLSEX <?>          

_hBmpMem1   dd ?

; 
; To change Display resolution
; 
_hWnd01      dd  ?
_hWnd02      dd  ?
_hWnd03      dd  ?
_hWnd04      dd  ?
_hWnd05      dd  ?
_hWnd06      dd  ?
_hWnd07      dd  ?
_hWnd08      dd  ?
_hWnd09      dd  ?
_hWnd10      dd  ?

_ScreenRes  DEVMODE <>
;  Code Section 
.code
;---------------------------------------
start:
    invoke  GetModuleHandle, NULL
    mov     _hInstance, eax

    invoke    InitCommonControlsEx, ADDR _icce

    invoke  WinMain, _hInstance, NULL, NULL, SW_SHOWDEFAULT

; ##############################################################################################
align 16
WinMain     proc hInst:DWORD, hPrevInst:DWORD, CmdLine:DWORD, CmdShow:DWORD

            ;.................................................................
            ;
            ; Preencher a estrutura WNDCLASSEX para a janela 1
            ; ------------------------------------------------
	      mov   _wcx.cbSize,      SIZEOF WNDCLASSEX
            mov   _wcx.style,       3 or CS_BYTEALIGNCLIENT or CS_OWNDC         
    	      mov   _wcx.lpfnWndProc, OFFSET WndProcA
        	mov   _wcx.cbClsExtra,  NULL
	      mov   _wcx.cbWndExtra,  NULL
	      push  _hInstance
	      pop   _wcx.hInstance
            invoke  CreateSolidBrush, 0
        	mov   _wcx.hbrBackground, eax          ; COLOR_BACKGROUND+1           
	      mov   _wcx.lpszMenuName, offset _MenuName              ; menu name in resource file
	      mov   _wcx.lpszClassName, OFFSET _ClassName            ; name of windows class
            ;invoke LoadIcon, hInst, offset _IconName     
            mov    _wcx.hIcon, NULL                         ;eax
            mov    _wcx.hIconSm, NULL
        	invoke LoadCursor, NULL, IDC_ARROW
        	mov   _wcx.hCursor, eax

            invoke RegisterClassEx, addr _wcx
            ;
            ; Cria a janela
            ; -------------
	      invoke CreateWindowEx, MAIN_EXTSTYLE, addr _ClassName, addr _WindowName, MAIN_STYLE,
                                   0, 0, 1280, 990, NULL, NULL, hInst, NULL
            mov     _hWnd, eax                                     

            ; 
            ; Get Display DC
            ; 
            call    GetDisplayDC

            invoke  ShowWindow, _hWnd, SW_SHOWNORMAL
            invoke  UpdateWindow, _hWnd   
;#############################################################################
            ;
            ; Loop de espera de mensagens
            ;
@@:         invoke  GetMessage, ADDR _msg, NULL, 0, 0                       
            cmp     eax,0h                              ;check if return value=0 => exit
            je      @F                                  ;go forward @@

            invoke  TranslateMessage, ADDR _msg 
            invoke  DispatchMessage,  ADDR _msg
            jmp     @B                                  ;go backward @@                  
            ;
            ; Termina o programa
            ;-------------------
@@:         invoke  ExitProcess, 0          
WinMain     endp
; ----------------------------------------------------------------------------------------------
CmdProc         proc    hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD 
                ;
_iCmdProc::     SWITCH  edx

                case    IDM_Menu1       ; Qualquer Coisa


                case    IDM_Menu2       ; Change Resolution

                    ; 
                    ; Open Dialog Box
                    ; 
                    DIALOGBOX _DlgMain, EcraRes

                case    IDM_Menu3       ; Fecha
                
                    invoke    SendMessage, _hWnd, WM_CLOSE, 0, 0

                default
                    jmp      _EndProcA
                ENDSW
                ;
                ; Command was processed
                ; *********************
_eCmdProc::     mov     eax, 0
                ret
CmdProc         endp
; 
WndProcA        proc    hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

                mov     edx, wParam
                mov     eax, uMsg
                ;               
                cmp     eax, WM_COMMAND
                je      _iCmdProc               ; go to CmdProc           
                ;
                cmp     eax, WM_PAINT
                je      _WM_PAINT 
                ;
                cmp     eax, WM_CREATE
                je      _WM_CREATE
                ;
                cmp     eax, WM_SIZE
                je      _WM_SIZE
                
                cmp     eax, WM_CLOSE
                je      _WM_CLOSE

                cmp     eax, WM_DESTROY
                je      _WM_DESTROY
                
                cmp     eax, WM_SYSCOMMAND
                je      _WM_SYSCOMMAND
                ;
                cmp     eax, WM_DISPLAYCHANGE
                je      _WM_DISPLAYCHANGE
                
                jmp     _EndProcA

;------------------------------------------------------------------
;                             WM_PAINT
;------------------------------------------------------------------
_WM_PAINT:
                ;LOADIMAGEM  _BitMap0
                LOADIMAGEM  _BitMap1
                
                invoke   BitBlt, _hdc, 0, 0, $ECRAWIDTH$, $ECRAHEIGHT$, _hMemDC, 0, 0, SRCCOPY
                invoke   DeleteObject, _hBitmapX
                jmp       _ExitProcA
; -----------------------------------------------------------------
;                             WM_SYSCOMMAND
; -----------------------------------------------------------------
_WM_SYSCOMMAND: cmp     edx, SC_CLOSE
                jne     _EndProcA
; -----------------------------------------------------------------
;                             WM_CLOSE
; -----------------------------------------------------------------
_WM_CLOSE::     invoke   DestroyWindow,  hWnd
                jmp     _ExitProcA
; -----------------------------------------------------------------
;                             WM_DESTROY
; -----------------------------------------------------------------
_WM_DESTROY:    invoke   PostQuitMessage, NULL
                jmp     _ExitProcA 
; -----------------------------------------------------------------
;                             WM_CREATE
; -----------------------------------------------------------------
_WM_CREATE:    
                CREATESTATUS _hWndStat, 500h
                invoke  SetWindowLong, _hWndStat, GWL_WNDPROC, offset StatusProc
                mov     _wStatus, eax

                invoke     SetFocus, _hWndStat

                jmp       _ExitProcA                
;------------------------------------------------------------------
;                            WM_DISPLAYCHANGE
; -----------------------------------------------------------------
_WM_DISPLAYCHANGE:  invoke    UpdateWindow, hWnd
                    jmp       _ExitProcA

; -----------------------------------------------------------------
;                             WM_SIZE
; -----------------------------------------------------------------
_WM_SIZE:       
                invoke    GetClientRect, _hWnd, addr _MemLeftX
                jmp       _ExitProcA
; -----------------------------------------------------------------
_EndProcA::     invoke   DefWindowProc, hWnd, uMsg, wParam, lParam                
                ret
                ;
_ExitProcA::    mov     eax, 0
                ret
WndProcA        endp    
; ##############################################################################################
                                include Screen5.inc
; 
    end     start

